local PartyBuffsImprovedLIB_MAJOR, PartyBuffsImprovedLIB_MINOR = "PartyBuffsImprovedLib", 0.50
local PartyBuffsImprovedLib = _G[PartyBuffsImprovedLIB_MAJOR]

if not PartyBuffsImprovedLib or PartyBuffsImprovedLib.minor < PartyBuffsImprovedLIB_MINOR then 
	PartyBuffsImprovedLib = PartyBuffsImprovedLib or { }
	_G[PartyBuffsImprovedLIB_MAJOR] = PartyBuffsImprovedLib
	PartyBuffsImprovedLib.minor = PartyBuffsImprovedLIB_MINOR

	PartyBuffsImprovedLib.commands = { count = 0 }

	SLASH_PartyBuffsImproved1 = "/PartyBuffsImproved"
	SlashCmdList["PartyBuffsImproved"] = function(msg) PartyBuffsImprovedLib:slashHandler(msg) end

	function PartyBuffsImprovedLib:commandsInit(cmd,desc,fnct)
		
		-- Initialize soulmsg
		PartyBuffsImprovedLib.commands.count = PartyBuffsImprovedLib.commands.count + 1
		PartyBuffsImprovedLib.commands[PartyBuffsImprovedLib.commands.count] = { }
		PartyBuffsImprovedLib.commands[PartyBuffsImprovedLib.commands.count].cmd = cmd
		PartyBuffsImprovedLib.commands[PartyBuffsImprovedLib.commands.count].desc = desc
		if type( fnct ) == "string" then
			PartyBuffsImprovedLib.commands[PartyBuffsImprovedLib.commands.count].func = function(msg, index)
				self[fnct](PartyBuffsImprovedLib, msg, index)
			end
		else
			PartyBuffsImprovedLib.commands[PartyBuffsImprovedLib.commands.count].func = fnct
		end
	end

	function PartyBuffsImprovedLib:printHelp()
		DEFAULT_CHAT_FRAME:AddMessage("/PartyBuffsImproved commands:")
		for i = 1, PartyBuffsImprovedLib.commands.count do
			DEFAULT_CHAT_FRAME:AddMessage(" - "..PartyBuffsImprovedLib.commands[i].cmd..": "..PartyBuffsImprovedLib.commands[i].desc)
		end
	end

	-- Internal function to pick which channel to should get the messages.
	function PartyBuffsImprovedLib:slashParser(msg)
		local firstspace = string.find(msg, " ", 1, true)
		if (firstspace) then
			local command = string.sub(msg, 1, firstspace - 1)
			local option = string.sub(msg, firstspace + 1)
			return command, option
		else
			return msg, nil
		end
	end

	function PartyBuffsImprovedLib:slashHandler(msg)
		
		local carg1, carg2 = PartyBuffsImprovedLib:slashParser(msg)
		local matchfound = false
		
		if carg1 then
			carg1 = string.lower(carg1)
		end
		
		if ( not carg1 ) then
			PartyBuffsImprovedLib:printHelp()
		else
			for i = 1, PartyBuffsImprovedLib.commands.count do
				if ( carg1 == PartyBuffsImprovedLib.commands[i].cmd ) then
					matchfound = true
					PartyBuffsImprovedLib.commands[i].func(carg2,i)
				end
			end
			if ( not matchfound ) then
				PartyBuffsImprovedLib:printHelp()
			end
		end    
	end

	function PartyBuffsImprovedLib:getCmdindex(cmd)
		for i = 1, PartyBuffsImprovedLib.commands.count do
			if ( cmd == PartyBuffsImprovedLib.commands[i].cmd ) then
				return i
			end
		end
		return false
	end
	
	-- Compatibility Functions
	function PartyBuffsImprovedCmdInit(cmd,desc,fun)
		DEFAULT_CHAT_FRAME:AddMessage("One of your PartyBuffsImproved mods is out of date!  Please update PartyBuffsImprovedBuffDisplay or PartyBuffsImprovedStones.")
		PartyBuffsImprovedLib:commandsInit(cmd,desc,func)
	end
	function PartyBuffsImprovedGetCmdIndex(cmd) PartyBuffsImprovedLib:getCmdindex(cmd) end
	PartyBuffsImprovedLIB_VER = PartyBuffsImprovedLIB_MINOR
end