local PBIMJR, PBIVER = "PartyBuffsImprovedPartyBuffs", "5.2.0"

local PartyBuffsImprovedLib = _G["PartyBuffsImprovedLib"]

PartyBuffsImprovedPartyBuffs = CreateFrame("Frame")
PartyBuffsImprovedPartyBuffs:RegisterEvent("UNIT_AURA")
PartyBuffsImprovedPartyBuffs:RegisterEvent("VARIABLES_LOADED")
PartyBuffsImprovedPartyBuffs:RegisterEvent("PARTY_MEMBERS_CHANGED")
PartyBuffsImprovedPartyBuffs:RegisterEvent("PLAYER_ENTERING_WORLD")
PartyBuffsImprovedPartyBuffs:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
PartyBuffsImprovedPartyBuffs:RegisterEvent("PLAYER_TALENT_UPDATE")
PartyBuffsImprovedPartyBuffs.version = PBIVER

PartyBuffsImprovedPartyBuffs.Options = {
	["max_party_buffs"] = 32,
	["max_party_debuffs"] = 40,
	["filter_castable"] = true
}

PartyBuffsImprovedPartyBuffs.CanDispel = {
	PRIEST = {
		Magic = true,
		Disease = true
	},
	SHAMAN = {
		Curse = true,
		Magic = true
	},
	PALADIN = {
		Poison = true,
		Disease = true,
		Magic = true
	},
	MAGE = {
		Curse = true,
	},
	DRUID = {
		Curse = true,
		Poison = true,
		Magic = true
	}
}

PartyBuffsImprovedPartyBuffs.frameref = {
	["party1"] = "PartyBuffsImprovedPartyBuffFrame1",
	["party2"] = "PartyBuffsImprovedPartyBuffFrame2",
	["party3"] = "PartyBuffsImprovedPartyBuffFrame3",
	["party4"] = "PartyBuffsImprovedPartyBuffFrame4"
}

PartyBuffsImprovedPartyBuffs.blizzframes = {
	["party1"] = "PartyMemberFrame1",
	["party2"] = "PartyMemberFrame2",
	["party3"] = "PartyMemberFrame3",
	["party4"] = "PartyMemberFrame4"
}

function PartyBuffsImprovedPartyBuffs:ErrorMsg(name, index)
	DEFAULT_CHAT_FRAME:AddMessage("/PartyBuffsImproved"..PartyBuffsImprovedLib.commands[index].cmd..": "..PartyBuffsImprovedLib.commands[index].desc)
	DEFAULT_CHAT_FRAME:AddMessage(PBI_CURRENT..PartyBuffsImprovedPartyBuffs.Options[name])
end

function PartyBuffsImprovedPartyBuffs:buffshandler(msg, index)
	if msg then
		msg = tonumber(msg)
		if ( msg > 0 and msg < 33 ) then
			if ( msg < PartyBuffsImprovedPartyBuffs.Options.max_party_buffs ) then
				for j = 1, GetNumGroupMembers() do
					local frame = "PartyBuffsImprovedPartyBuffFrame"..j
					for i = msg, PartyBuffsImprovedPartyBuffs.Options.max_party_buffs do
						local button = _G[frame.."Buff"..i]
						if button then
							button:Hide()
						end
					end
				end
			end
			PartyBuffsImprovedPartyBuffs.Options.max_party_buffs = msg
			for i = 1, GetNumGroupMembers() do
				PartyBuffsImprovedPartyBuffs:UpdateBuffs("party"..i)
			end
			
			DEFAULT_CHAT_FRAME:AddMessage(PBI_PBUFFS_CHANGED..msg)
		else
			PartyBuffsImprovedPartyBuffs:ErrorMsg("max_party_debuffs", index)
		end
	else
		PartyBuffsImprovedPartyBuffs:ErrorMsg("max_party_buffs",index)
	end
end

function PartyBuffsImprovedPartyBuffs:debuffshandler(msg, index)
	if msg then
		msg = tonumber(msg)
		if ( msg > 0 and msg < 33 ) then
			if ( msg < PartyBuffsImprovedPartyBuffs.Options.max_party_debuffs ) then
				for j = 1, GetNumGroupMembers() do
					local frame = "PartyBuffsImprovedPartyDebuffFrame"..j
					for i = msg, PartyBuffsImprovedPartyBuffs.Options.max_party_debuffs do
						local button = _G[frame.."Debuff"..i]
						if button then
							button:Hide()
						end
					end
				end
			end
			PartyBuffsImprovedPartyBuffs.Options.max_party_debuffs = msg
			for i = 1, GetNumGroupMembers() do
				PartyBuffsImprovedPartyBuffs:UpdateBuffs("party"..i)
			end
			
			DEFAULT_CHAT_FRAME:AddMessage(PBI_PDEBUFFS_CHANGED..msg)
		else
			PartyBuffsImprovedPartyBuffs:ErrorMsg("max_party_debuffs", index)
		end
	else
		PartyBuffsImprovedPartyBuffs:ErrorMsg("max_party_debuffs",index)
	end
end

function PartyBuffsImprovedPartyBuffs:filterhandler(msg, index)
	if msg then
		if ( msg == "on" ) then
			PartyBuffsImprovedPartyBuffs.Options.filter_castable = true
			DEFAULT_CHAT_FRAME:AddMessage(PBI_PFILTER_CHANGED..PBI_ENABLED)
		elseif ( msg == "off" ) then
			PartyBuffsImprovedPartyBuffs.Options.filter_castable = false
			DEFAULT_CHAT_FRAME:AddMessage(PBI_PFILTER_CHANGED..PBI_DISABLED)
		else
			DEFAULT_CHAT_FRAME:AddMessage("/PartyBuffsImproved"..PartyBuffsImprovedLib.commands[index].cmd..": "..PartyBuffsImprovedLib.commands[index].desc)
			if ( PartyBuffsImprovedPartyBuffs.Options.filter_castable == true ) then
				DEFAULT_CHAT_FRAME:AddMessage(PBI_CURRENT..PBI_ENABLED)
			else
				DEFAULT_CHAT_FRAME:AddMessage(PBI_CURRENT..PBI_DISABLED)
			end
		end
		for i = 1, GetNumGroupMembers() do
			PartyBuffsImprovedPartyBuffs:UpdateBuffs("party"..i)
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("/PartyBuffsImproved"..PartyBuffsImprovedLib.commands[index].cmd..": "..PartyBuffsImprovedLib.commands[index].desc)
		if ( PartyBuffsImprovedPartyBuffs.Options.filter_castable == true ) then
			DEFAULT_CHAT_FRAME:AddMessage(PBI_CURRENT..PBI_ENABLED)
		else
			DEFAULT_CHAT_FRAME:AddMessage(PBI_CURRENT..PBI_DISABLED)
		end
	end
end

function PartyBuffsImprovedPartyBuffs:onEvent(event, ...)
	PartyBuffsImprovedTargetFrame:onEvent(event, ...)
	local arg1 = ...
	if ( event == "VARIABLES_LOADED" ) then
		self["commandsInit"] = PartyBuffsImprovedLib["commandsInit"]
		self:commandsInit("maxpartybuffs", PBI_MAXPARTYBUFFS, "buffshandler")
		self:commandsInit("maxpartydebuffs", PBI_MAXPARTYDEBUFFS, "debuffshandler")
		self:commandsInit("partyaurafilter", PBI_FILTERDEBUFFS, "filterhandler")
		DEFAULT_CHAT_FRAME:AddMessage(PBI_LOADED)
	end
	if ( event == "UNIT_AURA" ) then
		for k, v in pairs(PartyBuffsImprovedPartyBuffs.frameref) do
			if ( arg1 == k ) then
				PartyBuffsImprovedPartyBuffs:UpdateBuffs(arg1)
				return
			end
		end
	end
	if ( event == "PARTY_MEMBERS_CHANGED" or event == "PLAYER_ENTERING_WORLD" ) then
		for i = 1, GetNumGroupMembers() do
			self:UpdateBuffs("party"..i)
		end
	end
	if ( event == "PLAYER_TALENT_UPDATE" or event == "ACTIVE_TALENT_GROUP_CHANGED" or event == "PLAYER_ENTERING_WORLD" ) then
		local _, eClass = UnitClass("player")
		if ( self.CanDispel[eClass] ) then
			self:TalentDetect(eClass)
		end
	end
end

PartyBuffsImprovedPartyBuffs:SetScript("OnEvent", PartyBuffsImprovedPartyBuffs["onEvent"])

function PartyBuffsImprovedPartyBuffs:UpdateBuffs(unit)
--~ 	DEFAULT_CHAT_FRAME:AddMessage("UpdateBuffs called for unit "..unit)
--~ 	Hide the Blizzard debuffs.
	for i = 1, 4 do
		_G[self.blizzframes[unit].."Debuff"..i]:Hide()
	end
	
	local frame = self.frameref[unit]
	local button, buttonname
	local name, rank, icon, count, duration, expirationTime
	local buffCount
	local cooldown, startCooldownTime
	local filter_castable = nil
	
	if PartyBuffsImprovedPartyBuffs.Options.filter_castable then filter_castable = "PLAYER" end
	
	local i = 1
	while ( i <= PartyBuffsImprovedPartyBuffs.Options.max_party_buffs ) do
		name, rank, icon, count, debuffType, duration, expirationTime = UnitBuff(unit, i, filter_castable)
		buttonname = frame.."Buff"..i
		button = _G[buttonname]
		
		if ( not button ) then
			if ( not icon ) then
				break
			else
				button = CreateFrame("Button", buttonname, _G[frame], "PartyBuffsImprovedPartyBuffButtonTemplate")
			end
		end
		
		if ( icon ) then
			_G[buttonname.."Icon"]:SetTexture(icon)
			buffCount = _G[buttonname.."Count"]
			
			if (count > 1) then
				buffCount:SetText(count)
				buffCount:Show()
			else
				buffCount:Hide()
			end
			
			cooldown = _G[buttonname.."Cooldown"]
			if ( duration ) then
				if ( duration > 0 ) then
					cooldown:Show()
					CooldownFrame_SetTimer(cooldown, expirationTime - duration, duration, 1)
				else
					cooldown:Hide()
				end
			else
				cooldown:Hide()
			end
			
			button:SetID(i)
			
			button:ClearAllPoints()
			self:PositionButtons(frame.."Buff", i, frame, "Buff")
			
			button:Show()
		else
			button:Hide()
		end
		i = i + 1
	end
	
	local debuffType, color
	local debuffCount, debuffBorder
	local buttonname, button
	local debuffIdx = 0
	
	i = 1
	while ( i <= PartyBuffsImprovedPartyBuffs.Options.max_party_debuffs ) do
		
		name, rank, icon, count, debuffType, duration, expirationTime, i = PartyBuffsImprovedPartyBuffs:UnitDebuff(unit, i)
		
		debuffIdx = debuffIdx + 1
		buttonname = frame.."Debuff"..debuffIdx
		button = _G[buttonname]
		
		if ( not button ) then
			if ( not icon ) then
				break
			else
				button = CreateFrame("Button", buttonname, _G[frame], "PartyBuffsImprovedPartyDebuffButtonTemplate")
			end
		end
		
		if ( icon ) then
			debuffBorder = _G[buttonname.."Border"]
			
			_G[buttonname.."Icon"]:SetTexture(icon)
			debuffCount = _G[buttonname.."Count"]
			
			if ( debuffType ) then
				color = DebuffTypeColor[debuffType]
			else
				color = DebuffTypeColor["none"]
			end
			
			if (count > 1) then
				debuffCount:SetText(count)
				debuffCount:Show()
			else
				debuffCount:Hide()
			end
			
			cooldown = _G[buttonname.."Cooldown"]
			if ( duration ) then
				if ( duration > 0 ) then
					cooldown:Show()
					CooldownFrame_SetTimer(cooldown, expirationTime - duration, duration, 1)
				else
					cooldown:Hide()
				end
			else
				cooldown:Hide()
			end
			
			debuffBorder:SetVertexColor(color.r, color.g, color.b)
			
			button:SetID(debuffIdx)
			
			button:ClearAllPoints()
			self:PositionButtons(frame.."Debuff", debuffIdx, frame, "Debuff")
			
			button:Show()
		else
			button:Hide()
		end
		i = i + 1
	end
end

function PartyBuffsImprovedPartyBuffs:PositionButtons(name, index, frame, btype)
	local button = _G[name..index]
	local debuffBorder = _G[name..index.."Border"]
	if ( btype == "Buff" ) then
		if ( index == 1 ) then
			button:SetPoint("TOPLEFT", _G[frame], "TOPLEFT", 0, 0)
		elseif ( index == 17 ) then
			button:SetPoint("TOPLEFT", _G[name.."3"], "BOTTOM", 0, -2)
		else
			button:SetPoint("TOPLEFT", _G[name..(index - 1)], "TOPRIGHT", 2, 0)
		end
	else
		if ( index == 1 ) then
			debuffBorder:Hide()
			-- button:SetPoint("TOPLEFT", _G[frame], "TOPLEFT", 75, 38)
			button:SetPoint("TOPLEFT", _G[frame], "TOPLEFT", 75, 18)
			debuffBorder:SetPoint("CENTER", button, "CENTER", 0, 0)
			debuffBorder:Show()
		else
			button:SetPoint("TOPLEFT", _G[name..(index - 1)], "TOPRIGHT", 2, 0)
		end
	end
end

function PartyBuffsImprovedPartyBuffs:UnitDebuff(unit,id)
if not unit then return end
	local name, rank, icon, count, debuffType, duration, timeLeft = UnitDebuff(unit,id)

	if self.Options.filter_castable then
		local _, eClass = UnitClass("player")
		while ( ( id <= self.Options.max_party_debuffs ) and not ( ( self.CanDispel[eClass] and ( self.CanDispel[eClass][debuffType] == true ) ) or ( eClass == "PRIEST" and aura == "Interface\\Icons\\Spell_Holy_AshesToAshes" ) ) ) do
			id=id+1
			name, rank, icon, count, debuffType, duration, timeLeft = UnitDebuff(unit,id)
		end
		return name, rank, icon, count or 0, debuffType, duration, timeLeft, id
	else
		return name, rank, icon, count or 0, debuffType, duration, timeLeft, id
	end
end

function PartyBuffsImprovedPartyBuffs:TalentDetect(eClass)
	-- local findTalents = function(tab, searchval)
		-- for i = 1, GetNumTalents(tab, false, false) do
			-- local name, _, _, _, rank, _ = GetTalentInfo(tab, i, false, false, nil)
			-- if ( rank > 0 and name == searchval ) then
				-- return true
			-- end
		-- end
		-- return false
	-- end
	if ( eClass == "DRUID" ) then
		-- if ( findTalents(3, PBI_NATURES_CURE) ) then
		if ( GetSpecialization(4) ) then
			PartyBuffsImprovedPartyBuffs.CanDispel[eClass]["Magic"] = true
		else
			PartyBuffsImprovedPartyBuffs.CanDispel[eClass]["Magic"] = false
		end
	elseif ( eClass == "SHAMAN" ) then
		-- if ( findTalents(3, PBI_IMP_CLEANSE_SPI) ) then
		if ( GetSpecialization(3) ) then
			PartyBuffsImprovedPartyBuffs.CanDispel[eClass]["Magic"] = true
		else
			PartyBuffsImprovedPartyBuffs.CanDispel[eClass]["Magic"] = false
		end
	elseif ( eClass == "PALADIN" ) then
		-- if ( findTalents(1, PBI_SACRED_CLEANSING) ) then
		if ( GetSpecialization(3) ) then
			PartyBuffsImprovedPartyBuffs.CanDispel[eClass]["Magic"] = true
		else
			PartyBuffsImprovedPartyBuffs.CanDispel[eClass]["Magic"] = false
		end
	end
end

local oldPartyMemberBuffTooltip_Update = PartyMemberBuffTooltip_Update
local function newPartyMemberBuffTooltip_Update(self)
	oldPartyMemberBuffTooltip_Update(self)    
	if (not string.find(self.unit,"pet")) then
		PartyMemberBuffTooltip:Hide()
	end
end
PartyMemberBuffTooltip_Update = newPartyMemberBuffTooltip_Update

