local STFMJR, STFVER = "PartyBuffsImprovedTargetFrame", "4.0.1"
local PartyBuffsImprovedTargetFrame = _G[STFMJR] or { version = STFVER }
_G[STFMJR] = PartyBuffsImprovedTargetFrame

PartyBuffsImprovedTargetFrame.options = {
	["maxbuffs"] = 32,
	["maxdebuffs"] = 40,
	["showownbig"] = "off"
}

function PartyBuffsImprovedTargetFrame:onEvent(event, ...)
	if ( ( event == "VARIABLES_LOADED" ) ) then
		self["commandsInit"] = PartyBuffsImprovedLib["commandsInit"]
		self:commandsInit("showbuffs",PartyBuffsImproved_SHOWBUFFS_HELP,"showbuffsHandler")
		self:commandsInit("showdebuffs",PartyBuffsImproved_SHOWDEBUFFS_HELP,"showdebuffsHandler")
		self:commandsInit("showownbig",PartyBuffsImproved_SHOWOWN_HELP,"showownHandler")
		
		DEFAULT_CHAT_FRAME:AddMessage(PartyBuffsImprovedTARGETFRAME_WELCOME)
		
		self:showownHandler(PartyBuffsImprovedTargetFrame.options.showownbig,PartyBuffsImprovedLib:getCmdindex("showownbig"))
		self:showbuffsHandler(PartyBuffsImprovedTargetFrame.options.maxbuffs,PartyBuffsImprovedLib:getCmdindex("showbuffs"))
		self:showdebuffsHandler(PartyBuffsImprovedTargetFrame.options.maxdebuffs,PartyBuffsImprovedLib:getCmdindex("showdebuffs"))
	end
end

function PartyBuffsImprovedTargetFrame:showbuffsHandler(msg,index)
	if msg then
		msg = tonumber(msg)
		if ( PartyBuffsImprovedTargetFrame.options.maxbuffs > msg ) then
			local button
			for i = msg+1, PartyBuffsImprovedTargetFrame.options.maxbuffs do
				button = _G["TargetFrameBuff"..i]
				if ( button ) then
					button:Hide()
				end
			end
		end
		MAX_TARGET_BUFFS = msg
		PartyBuffsImprovedTargetFrame.options.maxbuffs = msg
		DEFAULT_CHAT_FRAME:AddMessage(PartyBuffsImproved_SHOWBUFFS..MAX_TARGET_BUFFS)
		TargetFrame_UpdateAuras(_G["TargetFrame"])
	else
		DEFAULT_CHAT_FRAME:AddMessage("/PartyBuffsImproved "..PartyBuffsImprovedLib.commands[index].cmd..": "..PartyBuffsImprovedLib.commands[index].desc)
		DEFAULT_CHAT_FRAME:AddMessage(PartyBuffsImproved_SHOWBUFFS..MAX_TARGET_BUFFS)
	end
end

function PartyBuffsImprovedTargetFrame:showdebuffsHandler(msg,index)
	if msg then
		msg = tonumber(msg)
		if ( PartyBuffsImprovedTargetFrame.options.maxdebuffs > msg ) then
			local button
			for i = msg+1, PartyBuffsImprovedTargetFrame.options.maxdebuffs do
				button = _G["TargetFrameDebuff"..i]
				if ( button ) then
					button:Hide()
				end
			end
		end
		MAX_TARGET_DEBUFFS = msg
		PartyBuffsImprovedTargetFrame.options.maxdebuffs = msg
		DEFAULT_CHAT_FRAME:AddMessage(PartyBuffsImproved_SHOWDEBUFFS..MAX_TARGET_DEBUFFS)
		TargetFrame_UpdateAuras(_G["TargetFrame"])
	else
		DEFAULT_CHAT_FRAME:AddMessage("/PartyBuffsImproved "..PartyBuffsImprovedLib.commands[index].cmd..": "..PartyBuffsImprovedLib.commands[index].desc)
		DEFAULT_CHAT_FRAME:AddMessage(PartyBuffsImproved_SHOWDEBUFFS..MAX_TARGET_DEBUFFS)
	end
end

function PartyBuffsImprovedTargetFrame:showownHandler(msg,index)
	if ( msg == "on" ) then
		LARGE_BUFF_SIZE = 21
		LARGE_BUFF_FRAME_SIZE = 23
		PartyBuffsImprovedTargetFrame.options.showownbig = msg
		DEFAULT_CHAT_FRAME:AddMessage(PartyBuffsImproved_SHOWOWNON)
	elseif ( msg == "off" ) then
		LARGE_BUFF_SIZE = 17
		LARGE_BUFF_FRAME_SIZE = 19
		PartyBuffsImprovedTargetFrame.options.showownbig = msg
		DEFAULT_CHAT_FRAME:AddMessage(PartyBuffsImproved_SHOWOWNOFF)
	else
		DEFAULT_CHAT_FRAME:AddMessage("/PartyBuffsImproved "..PartyBuffsImprovedLib.commands[index].cmd..": "..PartyBuffsImprovedLib.commands[index].desc)
		DEFAULT_CHAT_FRAME:AddMessage(PartyBuffsImproved_SHOWOWNCURRENT..PartyBuffsImprovedTargetFrame.options.showownbig)
	end
end
